#pragma NOIV               // Do not generate interrupt vectors


#include "fx2.h"
#include "fx2regs.h"
#include "fx2sdly.h"            // SYNCDELAY macro

extern BOOL GotSUD;             // Received setup data flag
extern BOOL Sleep;
extern BOOL Rwuen;
extern BOOL Selfpwr;

xdata volatile const BYTE LED0_ON _at_ 0x8800;
xdata volatile const BYTE LED0_OFF _at_ 0x8000;
xdata volatile const BYTE LED1_ON _at_ 0x9800;
xdata volatile const BYTE LED1_OFF _at_ 0x9000;
xdata volatile const BYTE LED2_ON _at_ 0xA800;
xdata volatile const BYTE LED2_OFF _at_ 0xA000;
xdata volatile const BYTE LED3_ON _at_ 0xB800;
xdata volatile const BYTE LED3_OFF _at_ 0xB000;

#define	min(a,b) (((a)<(b))?(a):(b))

#define GD_HID	0x21
#define GD_REPORT	0x22
#define CR_SET_REPORT 0x09
#define HID_OUTPUT_REPORT 2

#define BTN_ADDR		0x41
#define LED_ADDR		0x42

#define PF_IDLE			0
#define PF_GETKEYS		1

#define KEY_WAKEUP		0
#define KEY_F1			1
#define KEY_F2			2
#define KEY_F3			3

WORD	pHIDDscr;
WORD	pReportDscr;
WORD	pReportDscrEnd;
BYTE ledX_rdvar =0;
extern code HIDDscr;
extern code ReportDscr; 
extern code ReportDscrEnd;



 WORD VolCur = 0x0100;     /* Volume Current Value */
 WORD VolMin = 0x0001;     /* Volume Minimum Value */
 WORD VolMax = 0x7fff;     /* Volume Maximum Value */
 WORD VolRes = 0x0001;     /* Volume Resolution */



BYTE Configuration;             // Current configuration
BYTE AlternateSetting;          // Alternate settings

BYTE	Configuration;		// Current configuration
BYTE	AlternateSetting;	// Alternate settings

BYTE buttons;
BYTE oldbuttons;
BYTE leds = 0xFF;
BYTE mute=0x00;

BYTE read_buttons (void);
void write_leds (BYTE d);

#define VR_NAKALL_ON    0xD0
#define VR_NAKALL_OFF   0xD1
//-----------------------------------------------------------------------------
// Task Dispatcher hooks
//   The following hooks are called by the task dispatcher.
//-----------------------------------------------------------------------------





void TD_Init(void)             // Called once at startup
{
   // set the CPU clock to 48MHz
   CPUCS = ((CPUCS & ~bmCLKSPD) | bmCLKSPD1) ;

   // set the slave FIFO interface to 48MHz
   IFCONFIG |= 0x40;

  // Registers which require a synchronization delay, see section 15.14
  // FIFORESET        FIFOPINPOLAR
  // INPKTEND         OUTPKTEND
  // EPxBCH:L         REVCTL
  // GPIFTCB3         GPIFTCB2
  // GPIFTCB1         GPIFTCB0
  // EPxFIFOPFH:L     EPxAUTOINLENH:L
  // EPxFIFOCFG       EPxGPIFFLGSEL
  // PINFLAGSxx       EPxFIFOIRQ
  // EPxFIFOIE        GPIFIRQ
  // GPIFIE           GPIFADRH:L
  // UDMACRCH:L       EPxGPIFTRIG
  // GPIFTRIG
  
  // Note: The pre-REVE EPxGPIFTCH/L register are affected, as well...
  //      ...these have been replaced by GPIFTC[B3:B0] registers

  // default: all endpoints have their VALID bit set
  // default: TYPE1 = 1 and TYPE0 = 0 --> BULK  
  // default: EP2 and EP4 DIR bits are 0 (OUT direction)
  // default: EP6 and EP8 DIR bits are 1 (IN direction)
  // default: EP2, EP4, EP6, and EP8 are double buffered


//	 USBIE |= bmSOF;

    EP1OUTCFG = EP1INCFG = EP4CFG = EP8CFG = 0x06; // Disable unused endpoints
	SYNCDELAY;
    
    EP2CFG = 0x98;  // 4x buffered OUT isochronous endpoint
	SYNCDELAY;

	
	ledX_rdvar = LED0_ON;
	ledX_rdvar = LED1_ON;
	ledX_rdvar = LED2_ON;
	ledX_rdvar = LED3_ON;
    
	
/*	EP2BCL = 0x80;
	SYNCDELAY;
	EP2BCL = 0x80;
	SYNCDELAY;
	EP6BCL = 0x80;
	SYNCDELAY;
	EP6BCL = 0x80;
	SYNCDELAY;	  */
	FIFORESET = 0x80;
	SYNCDELAY;
	FIFORESET = 0x02;
	SYNCDELAY;
	FIFORESET = 0x00;
	SYNCDELAY;

	EP2FIFOCFG = 0x00;
	SYNCDELAY;		
//	EP2FIFOCFG = 0x10;
//	SYNCDELAY;		

  // we are just using the default values, yes this is not necessary...
  /*EP1OUTCFG = 0xA0;
  EP1INCFG = 0xA0;
  SYNCDELAY;                    // see TRM section 15.14
  EP2CFG = 0xA2;
  SYNCDELAY;                    
  EP4CFG = 0xA0;
  SYNCDELAY;                    
  EP6CFG = 0xE2;
  SYNCDELAY;                    
  EP8CFG = 0xE0;

  // out endpoints do not come up armed
  
  // since the defaults are double buffered we must write dummy byte counts twice
  SYNCDELAY;                    
  EP2BCL = 0x80;                // arm EP2OUT by writing byte count w/skip.
  SYNCDELAY;                    
  EP2BCL = 0x80;
  SYNCDELAY;                    
  EP4BCL = 0x80;                // arm EP4OUT by writing byte count w/skip.
  SYNCDELAY;                    
  EP4BCL = 0x80;    

  // enable dual autopointer feature
  AUTOPTRSETUP |= 0x01;

  Rwuen = TRUE;                 // Enable remote-wakeup
*/
}
BOOL adc_if_getrequest (void)		  // Servicing Audio SetUp Class Request
{


  if ( SETUPDAT[5] == 0x03 && SETUPDAT[4] == 0x00 ) 
  {
    /* Feature Unit: Interface = 0, ID = 3 */
    if ( SETUPDAT[2] == 0 || SETUPDAT[2] == 0x01) /*channel = 0 or channel = 1*/ 
	{
      
      switch ( SETUPDAT[3]) /* what control?*/
	  {
        case 0x01:                  /*mute control*/
          if (SETUPDAT[1] == 0x81) /*get_cur*/
		  {
              EP0BUF[0] = mute;
			  EP0BCH =0x00;
              
			  EP0BCL =0x01;
			  return(TRUE);
             
            
          }
		  break;
          
        case 0x02:                    /*volume control*/
          
            if (SETUPDAT[1] == 0x81)  /*get current value*/
            { 
		    
			EP0BUF[0] = LSB(VolCur);
			EP0BUF[1] = MSB(VolCur);
                                           /*range of current value is between 0x0001 and 0x7fff */
           
			  
              EP0BCH = 0;
			  
              EP0BCL = 2;

			  return(TRUE);
			}
			  
			                    
              if (SETUPDAT[1] == 0x82) /*get minimum value*/
            {  
			
			  EP0BUF[0] = LSB(VolMin);
              EP0BUF[1] = MSB(VolMin);
              
               EP0BCH = 0;
              
			  EP0BCL = 2;

			  return(TRUE);
            } 
			  
           
		   if (SETUPDAT[1]==0x83)      /*get maximum value*/
             {
			 
              EP0BUF[0] = LSB(VolMax);
              EP0BUF[1] = MSB(VolMax);
              EP0BCH = 0;
             
			  EP0BCL = 2;

			  return(TRUE);
              
			  }
           
		   if (SETUPDAT[1] == 0x84)   /*get resolution*/
             {
			 EP0BUF[0] = LSB(VolRes);
             EP0BUF[1] = MSB(VolRes);
             EP0BCH = 0;
			 EP0BCL = 2;

			 return(TRUE);
              
			 } 
          }
        }
    }
}




BOOL adc_if_setrequest(void) 
{

  if (SETUPDAT[5] == 0x03 && SETUPDAT[4] == 0x00 )
  {
    /* Feature Unit: Interface = 0, ID = 3 */
    if (SETUPDAT[2] == 0x00 || SETUPDAT[2] == 0x01 ) 
	{
      
      switch (SETUPDAT[3])
      {
        case 0x01:
          switch (SETUPDAT[1]) 
         {
            case 0x01:
			  EP0BCH =0;
			  EP0BCL =0;
              mute = EP0BUF[0];

			  return(TRUE);
              
          }
          break;
        case 0x02 :
          switch (SETUPDAT[1]) 
         {
            case 0x01:
              EP0BCH= 0x00;
			  EP0BCL =0x02;
			  VolCur = (( WORD )( EP0BUF[0] )<<8 ) | (WORD)( EP0BUF[1] ) ;
			 break;

			 return(TRUE);
             
          }
          
      }
    }
  }

  
}









void TD_Poll(void)              // Called repeatedly while the device is idle
{

if(!(EP2468STAT & bmEP2EMPTY))
	            { 
	                EP2BCL = 0x80;          // re(arm) EP2OUT
							   					ledX_rdvar = LED0_OFF;
					ledX_rdvar = LED1_OFF;
					//ledX_rdvar = LED3_ON;
					//ledX_rdvar = LED2_ON;
					//ledX_rdvar = LED3_OFF;
					if(EP2468STAT & bmEP2FULL)
					ledX_rdvar = LED3_OFF;

	            }

}

BOOL TD_Suspend(void)          // Called before the device goes into suspend mode
{
   return(TRUE);
}

BOOL TD_Resume(void)          // Called after the device resumes
{
   return(TRUE);
}

//-----------------------------------------------------------------------------
// Device Request hooks
//   The following hooks are called by the end point 0 device request parser.
//-----------------------------------------------------------------------------

BOOL DR_GetDescriptor(void)
{
		return(TRUE);
}

BOOL DR_SetConfiguration(void)   // Called when a Set Configuration command is received
{
   Configuration = SETUPDAT[2];
   return(TRUE);            // Handled by user code
}

BOOL DR_GetConfiguration(void)   // Called when a Get Configuration command is received
{
   EP0BUF[0] = Configuration;
   EP0BCH = 0;
   EP0BCL = 1;
   return(TRUE);            // Handled by user code
}

BOOL DR_SetInterface(void)       // Called when a Set Interface command is received
{
   AlternateSetting = SETUPDAT[2];

   if(AlternateSetting)
   {
   
		EP2CFG = 0x98;
		SYNCDELAY;
		EP1OUTCFG = EP1INCFG = EP4CFG = EP6CFG = EP8CFG = 0x06; 
	    SYNCDELAY;
		EP2BCL = 0x80; // arm first buffer by writing BC w/skip=1
	    SYNCDELAY;
	    EP2BCL = 0x80; // arm second buffer by writing BC w/skip=1        break;
		SYNCDELAY;
		EP2BCL = 0x80; // arm first buffer by writing BC w/skip=1
	    SYNCDELAY;
		EP2BCL = 0x80; // arm first buffer by writing BC w/skip=1
	    SYNCDELAY;
	}
	

   return(TRUE);            // Handled by user code
}

BOOL DR_GetInterface(void)       // Called when a Set Interface command is received
{
   EP0BUF[0] = AlternateSetting;
   EP0BCH = 0;
   EP0BCL = 1;
   return(TRUE);            // Handled by user code
}

BOOL DR_GetStatus(void)
{
   return(TRUE);
}

BOOL DR_ClearFeature(void)
{
   return(TRUE);
}

BOOL DR_SetFeature(void)
{
   return(TRUE);
}

BOOL DR_VendorCmnd(void)
{
  BYTE tmp;
  
  switch (SETUPDAT[1])
  {
     case VR_NAKALL_ON:
        tmp = FIFORESET;
        tmp |= bmNAKALL;      
        SYNCDELAY;                    
        FIFORESET = tmp;
        break;
     case VR_NAKALL_OFF:
        tmp = FIFORESET;
        tmp &= ~bmNAKALL;      
        SYNCDELAY;                    
        FIFORESET = tmp;
        break;
     default:
        return(TRUE);
  }

  return(FALSE);
}

//-----------------------------------------------------------------------------
// USB Interrupt Handlers
//   The following functions are called by the USB interrupt jump table.
//-----------------------------------------------------------------------------

// Setup Data Available Interrupt Handler
void ISR_Sudav(void) interrupt 0
{
   GotSUD = TRUE;            // Set flag
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSUDAV;         // Clear SUDAV IRQ
}

// Setup Token Interrupt Handler
void ISR_Sutok(void) interrupt 0
{
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSUTOK;         // Clear SUTOK IRQ
}

void ISR_Sof(void) interrupt 0
{
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSOF;            // Clear SOF IRQ
}

void ISR_Ures(void) interrupt 0
{
   // whenever we get a USB reset, we should revert to full speed mode
   pConfigDscr = pFullSpeedConfigDscr;
   ((CONFIGDSCR xdata *) pConfigDscr)->type = CONFIG_DSCR;
   pOtherConfigDscr = pHighSpeedConfigDscr;
   ((CONFIGDSCR xdata *) pOtherConfigDscr)->type = OTHERSPEED_DSCR;

   EZUSB_IRQ_CLEAR();
   USBIRQ = bmURES;         // Clear URES IRQ
}

void ISR_Susp(void) interrupt 0
{
   Sleep = TRUE;
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSUSP;
}

void ISR_Highspeed(void) interrupt 0
{
   if (EZUSB_HIGHSPEED())
   {
      pConfigDscr = pHighSpeedConfigDscr;
      ((CONFIGDSCR xdata *) pConfigDscr)->type = CONFIG_DSCR;
      pOtherConfigDscr = pFullSpeedConfigDscr;
      ((CONFIGDSCR xdata *) pOtherConfigDscr)->type = OTHERSPEED_DSCR;
   }

   EZUSB_IRQ_CLEAR();
   USBIRQ = bmHSGRANT;
}
void ISR_Ep0ack(void) interrupt 0
{
}
void ISR_Stub(void) interrupt 0
{
}
void ISR_Ep0in(void) interrupt 0
{
}
void ISR_Ep0out(void) interrupt 0
{
}
void ISR_Ep1in(void) interrupt 0
{
}
void ISR_Ep1out(void) interrupt 0
{
}
void ISR_Ep2inout(void) interrupt 0
{
}
void ISR_Ep4inout(void) interrupt 0
{
}
void ISR_Ep6inout(void) interrupt 0
{
}
void ISR_Ep8inout(void) interrupt 0
{
}
void ISR_Ibn(void) interrupt 0
{
}
void ISR_Ep0pingnak(void) interrupt 0
{
}
void ISR_Ep1pingnak(void) interrupt 0
{
}
void ISR_Ep2pingnak(void) interrupt 0
{
}
void ISR_Ep4pingnak(void) interrupt 0
{
}
void ISR_Ep6pingnak(void) interrupt 0
{
}
void ISR_Ep8pingnak(void) interrupt 0
{
}
void ISR_Errorlimit(void) interrupt 0
{
}
void ISR_Ep2piderror(void) interrupt 0
{
}
void ISR_Ep4piderror(void) interrupt 0
{
}
void ISR_Ep6piderror(void) interrupt 0
{
}
void ISR_Ep8piderror(void) interrupt 0
{
}
void ISR_Ep2pflag(void) interrupt 0
{
}
void ISR_Ep4pflag(void) interrupt 0
{
}
void ISR_Ep6pflag(void) interrupt 0
{
}
void ISR_Ep8pflag(void) interrupt 0
{
}
void ISR_Ep2eflag(void) interrupt 0
{
}
void ISR_Ep4eflag(void) interrupt 0
{
}
void ISR_Ep6eflag(void) interrupt 0
{
}
void ISR_Ep8eflag(void) interrupt 0
{
}
void ISR_Ep2fflag(void) interrupt 0
{
}
void ISR_Ep4fflag(void) interrupt 0
{
}
void ISR_Ep6fflag(void) interrupt 0
{
}
void ISR_Ep8fflag(void) interrupt 0
{
}
void ISR_GpifComplete(void) interrupt 0
{
}
void ISR_GpifWaveform(void) interrupt 0
{
}
